SELECT 1 AS Tag,
       NULL AS Parent,
       SalesOrderID AS [Sale!1!ID],
       NULL AS [OrderDate!2],
       NULL AS [CustomerID!3]
  FROM Sales.SalesOrderHeader
UNION ALL
SELECT 2 AS Tag,
       1 AS Parent,
       SalesOrderID,
       OrderDate, 
       NULL
FROM Sales.SalesOrderHeader
UNION ALL
SELECT 3 AS Tag,
       1 AS Parent,
       SalesOrderID,
       NULL, 
       CustomerID
FROM Sales.SalesOrderHeader
ORDER BY [Sale!1!ID], [CustomerID!3], [OrderDate!2]
FOR XML EXPLICIT, ROOT('Sale-List')

-- Ergebnis als relationale Ergebnismenge
/*
Tag  Parent   Sale!1!ID   OrderDate!2 CustomerID!3
---- -------- ----------- ----------- ------------
1    NULL     43659       NULL        NULL
2    1        43659       2001-07-01  NULL
3    1        43659       NULL        676
1    NULL     43660       NULL        NULL
2    1        43660       2001-07-01  NULL
3    1        43660       NULL        117
*/
-- Ergebnis in XML
/*
<Sale-List>
  <Sale ID="43659">
    <OrderDate>2001-07-01T00:00:00</OrderDate>
    <CustomerID>676</CustomerID>
  </Sale>
  <Sale ID="43660">
    <OrderDate>2001-07-01T00:00:00</OrderDate>
    <CustomerID>117</CustomerID>
  </Sale>
<Sale-List>
*/