SELECT 1 AS Tag,
       NULL         AS Parent,
       SalesOrderID AS [Sale!1!ID],
       NULL AS [Dates!2!OrderDate!ELEMENT],
       NULL AS [Dates!2!ShipDate!ELEMENT],
       NULL AS [Dates!2!DueDate!HIDE],
       NULL AS [Comment!3!ELEMENTXSINIL]
  FROM Sales.SalesOrderHeader
UNION ALL
SELECT 2 AS Tag,
       1 AS Parent,
       SalesOrderID,
       OrderDate, 
       ShipDate,
       DueDate,
       NULL
FROM Sales.SalesOrderHeader
UNION ALL
SELECT 3 AS Tag,
       1 AS Parent,
       SalesOrderID,
       NULL, 
       NULL,
       NULL,
       Comment
FROM Sales.SalesOrderHeader
ORDER BY [Sale!1!ID], Tag, [Dates!2!OrderDate!ELEMENT]
FOR XML EXPLICIT, ROOT('Sale-List')

-- Ergebnis als relationale Ergebnismenge
/*
Tag Parent Sale!1!ID Dates!2!    Dates!2!     Dates!2!    Comment!3!
                     OrderDate!  ShipDate!    DueDate!    ELEMENT
                     ELEMENT     ELEMENT      HIDE        XSINIL         
--- ------ --------- ----------- ------------ ----------- ----------
1   NULL   43659     NULL        NULL         NULL        NULL
2   1      43659     2001-07-01  2001-07-08   2001-07-13  NULL
3   1      43659     NULL        NULL         NULL        NULL
1   NULL   43660     NULL        NULL         NULL        NULL
2   1      43660     2001-07-01  2001-07-08   2001-07-13  NULL
3   1      43660     NULL                     NULL        NULL 
*/
-- Ergebnis in XML
/*
<Sale-List>
  <Sale ID="43659">
    <Dates>
      <OrderDate>2001-07-01T00:00:00</OrderDate>
      <ShipDate>2001-07-08T00:00:00</ShipDate>
    </Dates>
    <Comment />
  </Sale>
<Sale-List>
*/