UNION ALL
SELECT 3 AS Tag,
       2 AS Parent,
        dep.DepartmentID,
        NULL,
        NULL,
        dep.DepartmentID,
        EmployeeID,
        StartDate,
        EndDate   
  FROM  HumanResources.Department AS dep INNER JOIN HumanResources.EmployeeDepartmentHistory AS edh
    ON  dep.DepartmentID = edh.DepartmentID
 WHERE  dep.DepartmentID < 3
 ORDER BY [Department!1!DepID], [Emp-List!2!DepID!HIDE], [Emp!3!Emp-ID]
FOR XML EXPLICIT, ROOT('Dep-List')

-- Ergebnis
/*
<Dep-List xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <Department DepID="1" Name="Engineering" GroupName="Research and Development">
    <Emp-List>
      <Emp Emp-ID="3">
        <StartDate>1997-12-12T00:00:00</StartDate>
        <EndDate xsi:nil="true" />
      </Emp>
      <Emp Emp-ID="4">
        <StartDate>1998-01-05T00:00:00</StartDate>
        <EndDate>2000-06-30T00:00:00</EndDate>
      </Emp>
    </Emp-List>
  </Department>
  <Department DepID="2" Name="Tool Design" GroupName="Research and Development">
    <Emp-List>
      <Emp Emp-ID="4">
        <StartDate>2000-07-01T00:00:00</StartDate>
        <EndDate xsi:nil="true" />
      </Emp>
      <Emp Emp-ID="5">
        <StartDate>1998-01-11T00:00:00</StartDate>
        <EndDate xsi:nil="true" />
      </Emp>
    </Emp-List>
  </Department>
</Dep-List>
*/