-- XML zerlegen

-- XML-Variable erstellen
DECLARE @productXML xml, @idoc int
-- XML abrufen
SET @productXML = (
SELECT  TOP 30 Name,
       ProductNumber,
       ListPrice
  FROM Production.Product
 ORDER BY ProductID DESC
FOR XML PATH('Product'), ROOT('Product-List'))
-- Standardzerlegung
EXEC sp_xml_preparedocument @idoc OUTPUT, @productXML
SELECT *
  FROM OPENXML(@idoc, '/Product-List',1)
 ORDER BY id

-- Ergebnis in XML
/*
<Product-List>
  <Product>
    <Name>Road-750 Black, 52</Name>
    <ProductNumber>BK-R19B-52</ProductNumber>
    <ListPrice>539.9900</ListPrice>
  </Product>
  <Product>
    <Name>Road-750 Black, 48</Name>
    <ProductNumber>BK-R19B-48</ProductNumber>
    <ListPrice>539.9900</ListPrice>
  </Product>
</Product-List>
*/
-- Ergebnis
/*
id  parent node localname     prefix  name  data prev text
    id     type                       space type
                                      uri
--- ------ ---- ------------- ------- ----- ---- ---- ---------------
1   NULL     1  Product-List  NULL    NULL  NULL NULL NULL
2   0        1  Product       NULL    NULL  NULL NULL NULL
3   2        1  Name          NULL    NULL  NULL NULL NULL
118 0        1  Product       NULL    NULL  NULL 114  NULL
120 118      1  ProductNumber NULL    NULL  NULL 119  NULL
121 118      1  ListPrice     NULL    NULL  NULL 120  NULL
122 3        3  #text         NULL    NULL  NULL NULL Road-750 Black, 52
*/