using System;
using System.Collections.Generic;
using System.Text;
using ConsoleApplication1.localhost;
using System.Data;

namespace Client1 {
 class Program  {
   static void Main(string[] args){
     // Parameterwert abfragen
     Console.WriteLine("Geben Sie eine Mitarbeiternummer ein: ");
     string employeeId = Console.ReadLine();
     // Stellvertreter-Objekt fr Webservice erstellen
     epEmployee proxy = new epEmployee();
     proxy.Credentials = System.Net.CredentialCache.DefaultCredentials;
     // Webservice nutzen
     try {
       // Parameter in SQL-Anweisung ankndigen
       SqlParameter param = new SqlParameter();
       param.name = "x";
       param.sqlDbType = sqlDbTypeEnum.Int;
       param.Value = employeeId;
       param.direction = ConsoleApplication1.localhost.ParameterDirection.Input;
       SqlParameter[] queryParams = new SqlParameter[] { param };
       // SQL-Anweisungen sammeln
       string sql = "SELECT COUNT(*) AS Anzahl FROM HumanResources.Employee;"
                    + " SELECT * FROM HumanResources.Employee WHERE EmployeeID = @x";
       // Webservice verwenden
       object[] results = proxy.sqlbatch(sql, ref queryParams);
       // Objekte/Variablen fr Ergebnisse
       DataSet ds = null;
       long rowCount = 0;
       string message = string.Empty;
       int i = 1;
       // Objekte der Ergebnismenge untersuchen
       foreach (object o in results){
         if (o is DataSet){
           ds = (DataSet)o;
           ds.WriteXmlSchema("c:/schema" + i + ".xsd");
           ds.WriteXml("c:/xml" + i + ".xml");
           i++;
         }
         else if (o is SqlRowCount) rowCount = ((SqlRowCount)o).Count;
         else if (o is SqlMessage) message = ((SqlMessage)o).Message; 
         Console.WriteLine("Reihen: " + rowCount  + " Nachricht: " + message);
       } 
     }
     catch (Exception e) {
       Console.WriteLine(e.Message);
     }
     Console.ReadLine();
    }
   } 
 }