using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using ConsoleApplication1.localhost;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            // XML-Bestellung als Zeichenkette (krzer als DOM)
            String orderText = "<c:ProductOrder xmlns:c=\"http://www.contoso.com/ProductOrder\"><c:ProductNumber>BA-8327</c:ProductNumber><c:Quantity>3</c:Quantity><c:AccountNumber>AW00019908</c:AccountNumber></c:ProductOrder>";
            // Bestellung in automatisch erstelltem Typ anlegen
            ProductOrderTypeorder order = new ProductOrderTypeorder();
            // Zeichenktte in XML umwandeln
            XmlDocument xmldoc = new XmlDocument();
            XmlDocumentFragment fragIn = xmldoc.CreateDocumentFragment();
            fragIn.InnerXml = orderText;
            XmlNode[] xmlnodes = new XmlNode[1];
            xmlnodes[0] = (XmlNode)fragIn;
            // Bestellung XML zuweisen
            order.Any = xmlnodes;
            // Webservice-Proxy anlegen
            epProduct proxy = new epProduct();
            proxy.Credentials = System.Net.CredentialCache.DefaultCredentials;
            // Webservice aufrufen und XML-Bestellung verschicken
            try
            {
                // Besttigung in automatisch erstelltem Typ anlegen
                ProductOrderType confirmation = proxy.ProductOrder(order);
                // 
                XmlNode[] nodeArr = confirmation.Any;
                String confirmationXml = nodeArr[0].InnerXml;
                String soapXml = nodeArr[0].OuterXml;
                Console.WriteLine(confirmationXml);
                Console.WriteLine("-----------------");
                Console.WriteLine(soapXml);

            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            Console.ReadLine();
        }
    }
}
