USE AdventureWorks
GO
DROP ENDPOINT epProduct
GO
EXEC sp_reserve_http_namespace N'http://localhost:80/sql' 
GO
CREATE ENDPOINT epProduct 
   STATE = STARTED
AS HTTP(
   PATH = '/sql', 
   AUTHENTICATION = (INTEGRATED, BASIC ), 
   PORTS = ( SSL ),
   SITE = 'localhost'
)
FOR SOAP (
   WEBMETHOD 'http://tempUri.org/'.'GetProductInfo' 
            (name='AdventureWorks.Production.GetProductInfo', 
             schema=STANDARD ),
   BATCHES = DISABLED,
   WSDL = DEFAULT,
   LOGIN_TYPE = MIXED,
   DATABASE = 'AdventureWorks',
   NAMESPACE = 'http://Adventure-Works/Products'
)
GO
USE master
EXEC sp_grantlogin @loginame='NOTEBOOK\Comelio'
EXEC sp_grantdbaccess @loginame='NOTEBOOK\Comelio'
GRANT CONNECT ON ENDPOINT::epProduct TO [NOTEBOOK\Comelio]
GO