using System;
using System.Collections.Generic;
using System.Text;
using SessionClient1.localhost;
using System.Data;

namespace SessionClient1
{
    class Program
    {
        static void Main(string[] args)
        {
            // Stellvertreter-Objekt fr Webservice erstellen
            epProduct proxy = new epProduct();
            proxy.Credentials = System.Net.CredentialCache.DefaultCredentials;
            // Webservice nutzen
            try
            {
                // Out-Parameter in SQL-Anweisung ankndigen
                SqlParameter param = new SqlParameter();
                param.name = "x";
                param.sqlDbType = sqlDbTypeEnum.Int;
                param.direction = SessionClient1.localhost.ParameterDirection.InputOutput;
                SqlParameter[] queryParams = new SqlParameter[] { param };
                // Webservice verwenden und Sitzung einrichten
                proxy.sqlSession = new sqlSession();
                proxy.sqlSession.initiate = true;
                proxy.sqlSession.MustUnderstand = true;
                proxy.ecn = new environmentChangeNotifications();
                proxy.ecn.transactionBoundary = true;
                // 1. Anweisung
                Console.WriteLine("Erster Aufruf");
                object[] res = proxy.sqlbatch("USE AdventureWorks; BEGIN TRAN; IF OBJECT_ID ('Production.Product2') IS NOT NULL BEGIN DROP TABLE Production.Product2; END;"
                                              + "CREATE TABLE Production.Product2 ( "
                                              + " ProductID     int IDENTITY(1,1) NOT NULL PRIMARY KEY,"
                                              + " Name          varchar(30) NOT NULL,"
                                              + " ProductNumber nvarchar(25) NOT NULL,"
                                              + " ListPrice     money NOT NULL);"
                                              + " DELETE FROM Production.Product2;"
                                              + " INSERT INTO Production.Product2 (Name, ProductNumber, ListPrice)VALUES ('LL Road ' + 'Seat Assembly', 'SA-R127', 550); --ROLLBACK TRAN;", ref queryParams);

                Program.printResult(res);

                // Viele weitere Anweisungen...
                // Sitzung beenden
                proxy.sqlSession.timeoutSpecified = false;
                proxy.sqlSession.terminate = true;
            }
            catch (Exception e)
            {
                Console.WriteLine("Ausnahme: " + e.StackTrace);
            }
            Console.ReadLine();
        }


        public static void printResult(object[] res)
        {
            for (int i = 0; i < res.Length; i++)
            {
                object e1;

                SqlMessage errorMessage;
                System.Xml.XmlElement xmlResult;
                SqlTransaction transaction;

                //System.Data.DataSet resultDS;
                e1 = res[i];

                //return value from SP is an int
                if (e1.GetType().IsPrimitive)
                {
                    Console.WriteLine("Return code = " + e1);
                }
                
                Console.WriteLine(e1.ToString() + ": ");
                switch (e1.ToString())
                {
                    case "SessionClient1.localhost.SqlRowCount":   
                        Console.WriteLine(((SqlRowCount)res[i]).Count);
                        break;

                    case "System.Xml.XmlElement":
                        xmlResult = (System.Xml.XmlElement)res[i];
                        Console.WriteLine(xmlResult.OuterXml);
                        break;

                    case "SessionClient1.localhost.SqlMessage":
                        errorMessage = (SqlMessage)res[i];
                        Console.WriteLine(errorMessage.Message);
                        Console.WriteLine(errorMessage.Source);
                        break;

                    case "SessionClient1.localhost.SqlTransaction":
                        transaction = (SqlTransaction)res[i];
                        Console.WriteLine(transaction.Descriptor.ToString());
                        Console.WriteLine(transaction.Type);
                        break;
                }
            }
        }
    }

}
