using System;
using System.Data;
using System.Data.SqlClient;
using Microsoft.SqlServer.Server;
using System.Data.SqlTypes;
using System.Data.Sql;
using SqlDataRecord = Microsoft.SqlServer.Server.SqlDataRecord;

namespace MSSql
{
    public class CustomWSDL
    {
        //[SqlProcedure()]
        public static void GenerateWSDL(SqlInt32 iEndPointID, SqlBoolean bIsSSL, SqlString strHost, SqlString strQueryString, SqlString strUserAgent)
        {
            SqlPipe spPipe = SqlContext.Pipe; 
            String strWSDL = "<wsdl:definitions xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\" xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\" xmlns:tns=\"http://Adventure-Works/Products\" targetNamespace=\"http://Adventure-Works/Products\" xmlns:s1=\"http://tempUri.org/\"><wsdl:types><xsd:schema xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" attributeFormDefault=\"qualified\" elementFormDefault=\"qualified\" targetNamespace=\"http://tempUri.org/\"><xsd:element name=\"GetProductInfo\"><xsd:complexType><xsd:sequence><xsd:element name=\"ProductNumber\"></xsd:element></xsd:sequence></xsd:complexType></xsd:element><xsd:element name=\"GetProductInfoResponse\"><xsd:complexType><xsd:sequence><xsd:element name=\"GetProductInfoResult\"></xsd:element></xsd:sequence></xsd:complexType></xsd:element></xsd:schema></wsdl:types><wsdl:message name=\"s1MsgGetProductInfoSoapIn\"><wsdl:part name=\"parameters\" element=\"s1:GetProductInfo\" /></wsdl:message><wsdl:message name=\"s1MsgGetProductInfoSoapOut\"><wsdl:part name=\"parameters\" element=\"s1:GetProductInfoResponse\" /></wsdl:message><wsdl:portType name=\"epProductSoap\"><wsdl:operation name=\"GetProductInfo\"><wsdl:input name=\"s1MsgGetProductInfoSoapIn\" message=\"tns:s1MsgGetProductInfoSoapIn\" /><wsdl:output name=\"s1MsgGetProductInfoSoapOut\" message=\"tns:s1MsgGetProductInfoSoapOut\" /></wsdl:operation></wsdl:portType><wsdl:binding name=\"epProductSoap\" type=\"tns:epProductSoap\"><soap:binding transport=\"http://schemas.xmlsoap.org/soap/http\" style=\"document\"/><wsdl:operation name=\"GetProductInfo\"><soap:operation soapAction=\"http://tempUri.org/GetProductInfo\" style=\"document\" /><wsdl:input name=\"s1MsgGetProductInfoSoapIn\"><soap:body use=\"literal\" /></wsdl:input><wsdl:output name=\"s1MsgGetProductInfoSoapOut\"><soap:body use=\"literal\" /></wsdl:output></wsdl:operation></wsdl:binding><wsdl:service name=\"epProduct\"><wsdl:port name=\"epProduct\" binding=\"tns:epProductSoap\"><soap:address location=\"http://localhost//sql\" /></wsdl:port></wsdl:service></wsdl:definitions>";
            ReturnWSDL(strWSDL, spPipe);
        }


       private static String RetrieveWSDL(SqlInt32 iEndPointID, SqlBoolean bIsSSL, SqlString strHost, SqlString strQueryString, SqlString strUserAgent, SqlPipe spPipe)
        {
            String strReturnValue = null;
            SqlConnection sqlConn = new SqlConnection("context connection = true");
            sqlConn.Open();
            SqlCommand myCommand = sqlConn.CreateCommand();
            if (null == myCommand)
            {
                spPipe.Send("Error creating SqlCommand object.");
                goto ret;
            }

            //myPipe.Send("Testing custom wsdl creation.");

            // example of the call to the default WSDL generation SP
            //    sp_http_generate_wsdl_defaultsimpleorcomplex 65540, 0, N'server', N'wsdl', N'myApp'
            myCommand.CommandText = "sys.sp_http_generate_wsdl_defaultsimpleorcomplex";
            myCommand.CommandType = CommandType.StoredProcedure;

            //myPipe.Send("SP to be called: " + myCommand.CommandText);

            if (!strQueryString.Value.StartsWith("wsdl", true, System.Globalization.CultureInfo.InvariantCulture))
            {
                spPipe.Send("Error: Not a WSDL request.");
                goto ret;
            }
            // set the parameter values
            myCommand.Parameters.Add(new SqlParameter("@EndpointID", SqlDbType.Int));
            myCommand.Parameters[0].Value = iEndPointID;
            myCommand.Parameters.Add(new SqlParameter("@IsSSL", SqlDbType.Bit));
            myCommand.Parameters[1].Value = bIsSSL;
            myCommand.Parameters.Add(new SqlParameter("@Host", SqlDbType.NVarChar, strHost.Value.Length));
            myCommand.Parameters[2].Value = strHost;
            if (strQueryString.Value.ToLower(System.Globalization.CultureInfo.InvariantCulture).IndexOf("extended") > 0)
            {
                //  generated WSDL will use SqlTypes for datatypes
                myCommand.Parameters.Add(new SqlParameter("@QueryString", SqlDbType.NVarChar, 11));
                myCommand.Parameters[3].Value = "wsdlcomplex";
            }
            else
            {
                myCommand.Parameters.Add(new SqlParameter("@QueryString", SqlDbType.NVarChar, 4));
                myCommand.Parameters[3].Value = "wsdl";
            }
            myCommand.Parameters.Add(new SqlParameter("@UserAgent", SqlDbType.NVarChar, strUserAgent.Value.Length));
            myCommand.Parameters[4].Value = strUserAgent;

            // execute query to retrieve WSDL
            SqlDataReader oReader = myCommand.ExecuteReader();
            if (null == oReader)
            {
                spPipe.Send("Error occurred during execution of SqlCommand.");
                goto ret;
            }

            if (oReader.HasRows)                // make sure there actually data from the server
            {
                if (oReader.Read())                // make sure the read doesn't fail
                {
                    strReturnValue = oReader.GetSqlValue(0).ToString();
                }
            }

        ret:
            return strReturnValue;
        }

       private static void ReturnWSDL(String strWSDL, SqlPipe spPipe)
        {
            int iMaxLength = 4000;
            SqlMetaData[] oMetaData = new SqlMetaData[1];
            oMetaData[0] = new SqlMetaData("XML_F52E2B61-18A1-11d1-B105-00805F49916B",
                                            SqlDbType.NVarChar,
                                            iMaxLength,
                                            1033, // US-EN
                                            SqlCompareOptions.None);
            if (null == oMetaData[0])
            {
                spPipe.Send("Fehler bei Erstellung des SqlMetaData-Objekts.");
                goto ret;
            }
           if (strWSDL.Length < iMaxLength)
                iMaxLength = strWSDL.Length;
            object[] aoResponse = new object[1];
            aoResponse[0] = new object();
            if (null == aoResponse[0])
            {
                spPipe.Send("Fehler bei Erstellung des SqlDataRecord-Behlters.");
                goto ret;
            }
            aoResponse[0] = strWSDL.Substring(0, iMaxLength);
            SqlDataRecord oRecord = new SqlDataRecord(oMetaData);
            if (null == oRecord)
            {
                spPipe.Send("Fehler bei Erstellung von SqlDataRecord.");
                goto ret;
            }
            oRecord.SetValues(aoResponse);
            spPipe.SendResultsStart(oRecord);
            spPipe.SendResultsRow(oRecord);
            int iccLeft = strWSDL.Length - iMaxLength;
            int iLength = strWSDL.Length;
            while (iccLeft > 0) 
            {
                if (iccLeft > iMaxLength)
                {
                    oRecord.SetString(0, strWSDL.Substring(iLength - iccLeft, iMaxLength));
                    spPipe.SendResultsRow(oRecord);
                    iccLeft = iccLeft - iMaxLength;
                }
                else 
                {
                    oRecord.SetString(0, strWSDL.Substring(iLength - iccLeft, iccLeft));
                    spPipe.SendResultsRow(oRecord);
                    iccLeft = 0;
                }
            }
            spPipe.SendResultsEnd();

            ret:
            return;
        }
    }
       
}
